package org.loom.appengine;

import org.loom.interceptor.AbstractImageValidationInterceptor;
import org.loom.servlet.params.FileParameter;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.Scope;

import com.google.appengine.api.images.Image;
import com.google.appengine.api.images.ImagesServiceFactory;

/**
 * Implementation of {@link AbstractImageValidationInterceptor} using Google 
 * AppEngine API
 * @author icoloma
 *
 */
@Scope(BeanDefinition.SCOPE_PROTOTYPE)
public class AppEngineImageValidator extends AbstractImageValidationInterceptor {

	@Override
	protected org.loom.interceptor.ImageData getImageData(FileParameter fileParam) {
		Image image = ImagesServiceFactory.makeImage(fileParam.getBytes());
		org.loom.interceptor.ImageData data = new org.loom.interceptor.ImageData();
		data.setFormat(image.getFormat().toString().toLowerCase());
    	data.setWidth(image.getWidth());
    	data.setHeight(image.getHeight());
    	return data;
	}
	
}
