package org.loom.appengine.converter;

import org.loom.converter.AbstractSimpleConverter;
import org.loom.i18n.MessagesRepository;
import org.loom.util.StringUtils;

import com.google.appengine.api.datastore.Cursor;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;

/**
 * Converts a {@link Cursor} to a String.
 * @author icoloma
 *
 */
public class CursorConverter extends AbstractSimpleConverter {

	protected CursorConverter() {
		super(Cursor.class);
	}

	@Override
	public Object getAsObject(String text) {
		return text == null? null : Cursor.fromWebSafeString(text);
	}

	@Override
	protected String getAsTextImpl(Object value, MessagesRepository repository) {
		return ((Cursor)value).toWebSafeString();
	}

}
