package org.loom.appengine.converter;

import org.loom.util.StringUtils;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;

/**
 * Converts a Google AppEngine Key to/from a String.
 * This converter can only be used for root entities. It stores the Key kind and will only 
 * serialize/deserialize the id value, converted to alpha string.
 * @author icoloma
 *
 */
public class KeyIdConverter extends AbstractRootKeyConverter {

	public KeyIdConverter(Class<?> persistentClass) {
		super(persistentClass);
	}

	@Override
	protected Object getAsObjectImpl(String paramName, String paramValue) {
		return KeyFactory.createKey(kind, StringUtils.alphaToNumber(paramValue));
	}

	@Override
	protected String getAsTextImpl(Key key) {
		return StringUtils.numberToAlpha(key.getId());
	}

}
