package org.loom.appengine.converter;

import org.loom.appengine.annotations.RootKey;
import org.loom.appengine.annotations.RootKey.RootKeyType;
import org.loom.binding.AnnotationContainer;
import org.loom.converter.AnnotationDrivenConverterFactory;
import org.simpleds.converter.Converter;
import org.springframework.stereotype.Component;

import com.google.appengine.api.datastore.Key;

/**
 * Create {@link Converter} for {@link Key} properties
 * @author Nacho
 *
 */
@Component
public class RootKeyConverterFactory implements AnnotationDrivenConverterFactory<RootKey> {

	public org.loom.converter.Converter getConverter(AnnotationContainer propertyWrapper, RootKey annotation) {
		if (propertyWrapper.getPropertyClass() != Key.class) {
			return null;
		}
		Class<?> persistentClass = annotation.value();
		return annotation.type() == RootKeyType.NAME? new KeyNameConverter(persistentClass) : new KeyIdConverter(persistentClass);
	}
	
	public Class<RootKey> getAnnotationClass() {
		return RootKey.class;
	}

}
